/*
 *  Copyright 2008 Mikhail Kryshen
 *
 *  This file is part of Charamega.
 *
 *  Charamega is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Charamega is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Charamega.  If not, see <http://www.gnu.org/licenses/>.
 */

package kryshen.charamega;

class CardModel {
    attribute x:Number;
    attribute y:Number;    
    attribute angle:Number;

    attribute field:FieldModel;
    attribute value:Integer;                
        
    attribute solved = false;        
    attribute opened = false;
    
    function open():Boolean {
        if (opened or solved) {
            return false;
        }
        
        if (field.opened1 == null) {
            opened = true;
            field.opened1 = this;
            return true;
        }
        
        if (field.opened2 == null) {
            opened = true;
            field.opened2 = this;
            return true;
        }
        
        return false;
    }
}
